%global enable_tests 1

Name:           nodejs-zipfile
Version:        0.3.4
Release:        4%{?dist}
Summary:        C++ library for handling zipfiles in Node.js

License:        BSD
URL:            https://github.com/springmeyer/node-zipfile
Source0:        http://registry.npmjs.org/zipfile/-/zipfile-%{version}.tgz
# Link against system libraries
Patch0:         nodejs-zipfile-libraries.patch
# Offered upstream - https://github.com/springmeyer/node-zipfile/pull/30
Patch1:         nodejs-zipfile-uv.patch

ExclusiveArch:  %{ix86} x86_64 %{arm}

BuildRequires:  nodejs-devel
BuildRequires:  node-gyp
BuildRequires:  libzip-devel
BuildRequires:  zlib-devel

%if 0%{?enable_tests}
BuildRequires:  npm(mocha)
BuildRequires:  npm(mkdirp)
%endif

%{?nodejs_default_filter}

%description
Bindings to libzip for handling zipfile archives in Node.js.


%prep
%setup -q -n package
%patch0 -p0 -b .libraries
%patch1 -p1 -b .uv
rm -rf deps node_modules
# Fix file names corrupted in NPM registry tar ball, see:
# https://github.com/springmeyer/node-zipfile/issues/29
mv test/data/Clément test/data/Clément
mv test/data/Clément/Olá.zip test/data/Clément/Olá.zip


%build
export CXXFLAGS="%{optflags}"
node-gyp rebuild
install -p -D -m0755 build/Release/_zipfile.node lib


%install
mkdir -p %{buildroot}/%{nodejs_sitearch}/zipfile
cp -pr package.json lib %{buildroot}/%{nodejs_sitearch}/zipfile
%nodejs_symlink_deps


%if 0%{?enable_tests}
%check
ln -s %{nodejs_sitelib} .
NODE_PATH=lib %{nodejs_sitelib}/mocha/bin/mocha -R spec
%endif


%files
%doc LICENSE.txt README.md
%{nodejs_sitearch}/zipfile


%changelog
* Wed Apr  3 2013 Tom Hughes <tom@compton.nu> - 0.3.4-4
- Filter out provide for Node.js native extension
- Enable tests

* Wed Mar 13 2013 Tom Hughes <tom@compton.nu> - 0.3.4-3
- Restrict supported architectures using ExclusiveArch
- Rebuild against node 0.10

* Sat Mar  2 2013 Tom Hughes <tom@compton.nu> - 0.3.4-2
- Fix permissions on _zipfile.node
- BuildRequire zlib-devel
- BuildRequire mkdirp for tests
- Link node_modules for tests
- Set NODE_PATH when running tests

* Sun Feb 10 2013 Tom Hughes <tom@compton.nu> - 0.3.4-1
- Initial build of 0.3.4
